"use strict";

const EXPORTED_SYMBOLS = ["CB_CONFIG"];

const CB_CONFIG = (function() {
    const APP_NAME = "yasearch";
    
    let config = {
        APP: {
            NAME: APP_NAME
        },
        BUILD: {
            DATE: "Fri Feb 03 2012 16:34:12 GMT+0400",
            REVISION: 34084
        },
        PLATFORM: {
            VERSION: 7
        },
        CORE: {
            CONTRACT_ID: "@yandex.ru/custombarcore;" + APP_NAME,
            CLASS_ID: Components.ID("{F25B83DE-5817-11DE-8EB3-C9A656D89593}")
        },
        PROTOCOLS: {
            APP: {
                SCHEME: APP_NAME,
                CONTRACT_ID: "@mozilla.org/network/protocol;1?name=" + APP_NAME,
                CLASS_ID: Components.ID("{1A2ADED0-64D1-11DE-8047-DBAA3A7E4459}")
            },
            XB: {
                SCHEME: "xb",
                CONTRACT_ID: "@mozilla.org/network/protocol;1?name=xb",
                CLASS_ID: Components.ID("{6BA7D0A8-A115-11DE-8D96-029555D89593}")
            }
        },
        PREFS_PATH: {
            XB_WIDGETS: APP_NAME + ".xbwidgets.",
            NATIVES: APP_NAME + ".native_comps.",
            STATIC: APP_NAME + ".static."
        }
    };
    
    function freeze(aObject) {
        if (!(aObject && typeof aObject == "object"))
            return aObject;

        Object.freeze(aObject);

        for each (let obj in aObject)
            if (typeof aObject == "object")
                freeze(obj);
        
        return aObject;
    }
    
    return freeze(config);
})();
